/*******************************************************************************
 * FoxDataProvider_Playlist generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxDataProvider_Playlist extends UIResourceDataProvider
    transient
    native
    config(Playlists)
    perobjectconfig
    hidecategories(Object,UIRoot);

struct native PlaylistPairing
{
    var name MapProvider;
    var name GameProvider;

    structdefaultproperties
    {
        MapProvider=None
        GameProvider=None
    }
};

var config array<config PlaylistPairing> PlaylistPairings;
var const localized string FriendlyName;
var const localized string FriendlyDescription;
var config bool bRandomCycle;
var const config bool bTournament;
var const config bool bClanSorting;
var const config bool bPartySorting;
var const config bool bCoop;
var const config bool bIsPreventedFromQuickStart;
var bool bIsInSearchFilter;
var bool bHidden;
var const config bool bHiddenFromPrivateMatches;
var const config bool bFeatured;
var config int MaxLevel;
var config int MinLevel;
var config int MaxPrestige;
var config int MinPrestige;
var const config int InitialCombatPoints;
var const config float XPMultiplier;
var const config float CPMultiplier;
var const config float GPMultiplier;
var const config int Difficulty;
var const config int MutatorToggleOverride;
var const config name DropName;
var const config array<config int> RequiredChunks;

// Export UFoxDataProvider_Playlist::execIsPlayGoReady(FFrame&, void* const)
native function bool IsPlayGoReady();

event bool IsConfigFiltered()
{
    local bool HasAnyValidPairing, GameFiltered, MapFiltered;
    local int I, K, L;
    local FoxDataStore_Playlists PlaylistDataStore;
    local FoxDataStore_MenuItems MenuItemDataStore;

    // End:0x0F
    if(bHidden)
    {
        return true;
    }
    PlaylistDataStore = FoxDataStore_Playlists(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxPlaylists'));
    MenuItemDataStore = FoxDataStore_MenuItems(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxMenuItems'));
    GameFiltered = true;
    MapFiltered = true;
    HasAnyValidPairing = false;
    I = 0;
    J0xE2:
    // End:0x372 [Loop If]
    if(I < PlaylistPairings.Length)
    {
        K = 0;
        J0x105:
        // End:0x2E3 [Loop If]
        if(K < PlaylistDataStore.PlaylistGameInfoProviders.Length)
        {
            // End:0x2D5
            if(PlaylistDataStore.PlaylistGameInfoProviders[K].Name == PlaylistPairings[I].GameProvider)
            {
                L = 0;
                J0x1A5:
                // End:0x2D2 [Loop If]
                if(L < MenuItemDataStore.GameModeProviders.Length)
                {
                    // End:0x2C4
                    if(MenuItemDataStore.GameModeProviders[L].Name == PlaylistDataStore.PlaylistGameInfoProviders[K].GameType)
                    {
                        GameFiltered = PlaylistDataStore.ShouldFilterGameMode(FoxDataProvider_GameModeInfo(MenuItemDataStore.GameModeProviders[L]).Name);
                        // [Explicit Break]
                        goto J0x2D2;
                    }
                    ++ L;
                    J0x2D2:
                    // [Loop Continue]
                    goto J0x1A5;
                }
                // [Explicit Break]
                goto J0x2E3;
            }
            ++ K;
            J0x2E3:
            // [Loop Continue]
            goto J0x105;
        }
        MapFiltered = PlaylistDataStore.ShouldFilteredMap(string(PlaylistPairings[I].MapProvider));
        // End:0x364
        if(!MapFiltered && !GameFiltered)
        {
            HasAnyValidPairing = true;
            // [Explicit Break]
            goto J0x372;
        }
        ++ I;
        J0x372:
        // [Loop Continue]
        goto J0xE2;
    }
    return !HasAnyValidPairing;
    //return ReturnValue;    
}

defaultproperties
{
    bIsInSearchFilter=true
}